/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/RemoveSmDataSetCommand.java#4 $
 *
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command;

import java.util.ArrayList;
import java.util.List;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.common.logging.MessageBundle;
import com.netapp.smcore.plugin.contracts.SmDeleteProtectionGroupRequest;
import com.netapp.smcore.plugin.contracts.SmDeleteProtectionGroupResponse;
import com.netapp.smcore.plugin.contracts.SmRequest;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;
import com.netapp.snapcenter.cli.utils.CLIUtils;
import com.netapp.spl.common.restclient.config.SMSRestConfiguration;
import com.netapp.spl.common.restclient.context.SMSRestInvocationContext;

@Parameters(resourceBundle = "snapcenter-cli", commandDescriptionKey = "cli.removesmdataset.command.description")
public class RemoveSmDataSetCommand extends AbstractSMSCommand {

    private static final String COMMANDNAME = MessageBundle
            .localizeMessage(CLIMsgKey.CLI_REMOVESMDATASET_COMMAND_NAME);

    @Parameter(names = { "-ResourceGroupNames" }, descriptionKey = "cli.removesmdataset.command.dataSetNames.option.description", required = true)
    private List<String> datasets = new ArrayList<String>();

    @Parameter(names = { "-Force" }, descriptionKey = "cli.removesmdataset.command.force.option.description")
    private boolean force;

    @Override
    public String getCommandName() {
        return COMMANDNAME;
    }

    @Override
    protected void processCommandArguments() throws CLIException {
        CLIUtils.promptUserToContinue(MessageBundle
                .localizeMessage(CLIMsgKey.CLI_REMOVESMDATASET_PROMPT_USER_REMOVE_DATASET));
    }

    @Override
    protected <T extends SmRequest> SMSRestInvocationContext<?, ?> getCommandSpecificSMSRestInvocationContext(
            T cmdRequest) {
        SMSRestInvocationContext<SmDeleteProtectionGroupRequest, SmDeleteProtectionGroupResponse> smsRestInvocationContext = new SMSRestInvocationContext<>();
        smsRestInvocationContext
                .setRequest((SmDeleteProtectionGroupRequest) cmdRequest);
        smsRestInvocationContext
                .setResponseClass(SmDeleteProtectionGroupResponse.class);
        smsRestInvocationContext
                .setServiceUrlPath(SMSRestConfiguration.SMS_DELETE_PROTECTION_GROUP_SERVICE_PATH);
        return smsRestInvocationContext;
    }

    public void setDatasets(List<String> datasets) {
        this.datasets = datasets;
    }

    public List<String> getDatasets() {
        return datasets;
    }
    public boolean isForce() {
        return force;
    }

    public void setForce(boolean force) {
        this.force = force;
    }

}
