/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/RemoveSmPolicyCommand.java#4 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command;

import java.util.ArrayList;
import java.util.List;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.common.logging.MessageBundle;
import com.netapp.smcore.plugin.contracts.SmDeletePolicyRequest;
import com.netapp.smcore.plugin.contracts.SmDeletePolicyResponse;
import com.netapp.smcore.plugin.contracts.SmRequest;
import com.netapp.snapcenter.cli.command.parser.CommaParameterSplitter;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;
import com.netapp.snapcenter.cli.utils.CLIUtils;
import com.netapp.spl.common.restclient.config.SMSRestConfiguration;
import com.netapp.spl.common.restclient.context.SMSRestInvocationContext;

@Parameters(resourceBundle = "snapcenter-cli", commandDescriptionKey = "cli.removesmpolicy.command.description")
public class RemoveSmPolicyCommand extends AbstractSMSCommand {

    private static final String COMMANDNAME = MessageBundle
            .localizeMessage(CLIMsgKey.CLI_REMOVESMPOLICY_COMMAND_NAME);

    @Parameter(names = { "-PolicyNames" }, descriptionKey = "cli.removesmpolicy.command.policyNames.option.description", required = true, splitter = CommaParameterSplitter.class)
    private List<String> policies = new ArrayList<String>();

    @Override
    public String getCommandName() {
        return COMMANDNAME;
    }

    @Override
    protected void processCommandArguments() throws CLIException {
    	//TODO: Validate policy names
        CLIUtils.promptUserToContinue(MessageBundle
                .localizeMessage(CLIMsgKey.CLI_REMOVESMPOLICY_PROMPT_USER_REMOVE_POLICY));
    }

    @Override
    protected <T extends SmRequest> SMSRestInvocationContext<?, ?> getCommandSpecificSMSRestInvocationContext(
            T cmdRequest) {
        SMSRestInvocationContext<SmDeletePolicyRequest, SmDeletePolicyResponse> smsRestInvocationContext = new SMSRestInvocationContext<>();
        smsRestInvocationContext.setRequest((SmDeletePolicyRequest) cmdRequest);
        smsRestInvocationContext.setResponseClass(SmDeletePolicyResponse.class);
        smsRestInvocationContext
                .setServiceUrlPath(SMSRestConfiguration.SMS_DELETE_POLICY_SERVICE_PATH);
        return smsRestInvocationContext;
    }

    public void setPolicies(List<String> policies) {
        this.policies = policies;
    }

    public List<String> getPolicies() {
        return policies;
    }
}
