/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/RemoveSmStorageConnectionCommand.java#4 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.common.logging.MessageBundle;
import com.netapp.smcore.plugin.contracts.SmRemoveStorageConnectionRequest;
import com.netapp.smcore.plugin.contracts.SmRemoveStorageConnectionResponse;
import com.netapp.smcore.plugin.contracts.SmRequest;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;
import com.netapp.snapcenter.cli.utils.CLIUtils;
import com.netapp.spl.common.restclient.config.SMSRestConfiguration;
import com.netapp.spl.common.restclient.context.SMSRestInvocationContext;

@Parameters(resourceBundle = "snapcenter-cli", commandDescriptionKey = "cli.removesmstorageconnection.command.description")
public class RemoveSmStorageConnectionCommand extends AbstractSMSCommand {

    private static final String COMMANDNAME = MessageBundle
            .localizeMessage(CLIMsgKey.CLI_REMOVESMSTORAGECONNECTION_COMMAND_NAME);

    @Parameter(names = { "-SVM" }, descriptionKey = "cli.removesmstorageconnection.command.svm.option.description", required = true)
    private String storageVM;

    @Override
    public String getCommandName() {
        return COMMANDNAME;
    }

    @Override
    protected void processCommandArguments() throws CLIException {
        CLIUtils.promptUserToContinue(MessageBundle
                .localizeMessage(CLIMsgKey.CLI_REMOVESMSTORAGECONNECTION_PROMPT_USER_REMOVE_STORAGE_CONNECTION));
    }

    @Override
    protected <T extends SmRequest> SMSRestInvocationContext<?, ?> getCommandSpecificSMSRestInvocationContext(
            T cmdRequest) {
        SMSRestInvocationContext<SmRemoveStorageConnectionRequest, SmRemoveStorageConnectionResponse> smsRestInvocationContext = new SMSRestInvocationContext<>();
        smsRestInvocationContext.setRequest((SmRemoveStorageConnectionRequest) cmdRequest);
        smsRestInvocationContext.setResponseClass(SmRemoveStorageConnectionResponse.class);
        smsRestInvocationContext
                .setServiceUrlPath(SMSRestConfiguration.SMS_REMOVE_STORAGE_CONNECTION_SERVICE_PATH);
        return smsRestInvocationContext;
    }

    public String getStorageVM() {
        return storageVM;
    }

    public void setStorageVM(String storageVM) {
        this.storageVM = storageVM;
    }

}
