/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/invokesmcloneresourcesplit/InvokeSmCloneResourceSplitRestCallFactory.java#4 $
 *
 * Copyright (c) 2017 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.invokesmcloneresourcesplit;

import com.netapp.common.logging.MessageBundle;
import com.netapp.smcore.loader.logger.ExtendedGenericLogger;
import com.netapp.smcore.loader.logger.LoggerFactory;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitEstimateRequest;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitEstimateResponse;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitStartRequest;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitStartResponse;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitStatusRequest;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitStatusResponse;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitStopRequest;
import com.netapp.smcore.plugin.contracts.SmCloneResourceSplitStopResponse;
import com.netapp.smcore.plugin.contracts.SmRequest;
import com.netapp.spl.common.restclient.config.SMSRestConfiguration;
import com.netapp.spl.common.restclient.context.SMSRestInvocationContext;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

public class InvokeSmCloneResourceSplitRestCallFactory {

    private static ExtendedGenericLogger logger = LoggerFactory
            .getExtendedClassAwareLogger(InvokeSmCloneResourceSplitRestCallFactory.class);

    public static SMSRestInvocationContext<?, ?> getCommandSpecificSMSRestInvocationContext(
            CloneSplitCommandSubType cloneSplitCommandSubType,
            SmRequest cmdRequest) {

        switch (cloneSplitCommandSubType) {
            case ESTIMATE:
                SMSRestInvocationContext<SmCloneResourceSplitEstimateRequest, SmCloneResourceSplitEstimateResponse> smsRestInvocationContextForEstimate = new SMSRestInvocationContext<>();
                smsRestInvocationContextForEstimate
                        .setRequest((SmCloneResourceSplitEstimateRequest) cmdRequest);
                smsRestInvocationContextForEstimate
                        .setResponseClass(SmCloneResourceSplitEstimateResponse.class);
                smsRestInvocationContextForEstimate
                        .setServiceUrlPath(SMSRestConfiguration.SMS_CLONE_SPLIT_ESTIMATE_SERVICE_PATH);
                return smsRestInvocationContextForEstimate;
            case START:
                SMSRestInvocationContext<SmCloneResourceSplitStartRequest, SmCloneResourceSplitStartResponse> smsRestInvocationContextForStart = new SMSRestInvocationContext<>();
                smsRestInvocationContextForStart
                        .setRequest((SmCloneResourceSplitStartRequest) cmdRequest);
                smsRestInvocationContextForStart
                        .setResponseClass(SmCloneResourceSplitStartResponse.class);
                smsRestInvocationContextForStart
                        .setServiceUrlPath(SMSRestConfiguration.SMS_CLONE_SPLIT_START_SERVICE_PATH);
                return smsRestInvocationContextForStart;
            case STATUS:
                SMSRestInvocationContext<SmCloneResourceSplitStatusRequest, SmCloneResourceSplitStatusResponse> smsRestInvocationContextForStatus = new SMSRestInvocationContext<>();
                smsRestInvocationContextForStatus
                        .setRequest((SmCloneResourceSplitStatusRequest) cmdRequest);
                smsRestInvocationContextForStatus
                        .setResponseClass(SmCloneResourceSplitStatusResponse.class);
                smsRestInvocationContextForStatus
                        .setServiceUrlPath(SMSRestConfiguration.SMS_CLONE_SPLIT_STATUS_SERVICE_PATH);
                return smsRestInvocationContextForStatus;
            case STOP:
                SMSRestInvocationContext<SmCloneResourceSplitStopRequest, SmCloneResourceSplitStopResponse> smsRestInvocationContextForStop = new SMSRestInvocationContext<>();
                smsRestInvocationContextForStop
                        .setRequest((SmCloneResourceSplitStopRequest) cmdRequest);
                smsRestInvocationContextForStop
                        .setResponseClass(SmCloneResourceSplitStopResponse.class);
                smsRestInvocationContextForStop
                        .setServiceUrlPath(SMSRestConfiguration.SMS_CLONE_SPLIT_STOP_SERVICE_PATH);
                return smsRestInvocationContextForStop;
            default:
                logger.error(MessageBundle
                        .localizeMessage(CLIMsgKey.CLI_COMMAND_INVOKESMCLONERESOURCESPLIT_UNKNOWN_OPTION_ERROR));
                return null;

        }
    }
}
