/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/BackupPolicyParameters.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parameters;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;

@Parameters(resourceBundle = "snapcenter-cli")
public class BackupPolicyParameters implements ParameterInterface {

    @Parameter(names = { "-UpdateSnapMirrorAfterbackup" }, descriptionKey = "cli.smpolicy.command.updateSnapMirrorAfterbackup.option.description")
    private boolean updateSnapMirrorAfterbackup;

    @Parameter(names = { "-UpdateSnapVaultAfterbackup" }, descriptionKey = "cli.smpolicy.command.updateSnapVaultAfterbackup.option.description")
    private boolean updateSnapVaultAfterbackup;

    @Parameter(names = { "-MirrorVaultUpdateRetryCount" }, descriptionKey = "cli.smpolicy.command.mirrorVaultUpdateRetryCount.option.description")
    private int mirrorVaultUpdateRetryCount = 3;

    @Parameter(names = { "-SnapVaultLabel" }, descriptionKey = "cli.smpolicy.command.snapVaultLabel.option.description")
    private String snapVaultLabel;

    @Parameter(names = { "-DeleteBackupInExcess" }, descriptionKey = "cli.smpolicy.command.deleteBackupInExcess.option.description")
    private Integer deleteBackupInExcess;

    @Parameter(names = { "-DeleteBackupOlderThan" }, descriptionKey = "cli.smpolicy.command.deleteBackupOlderThan.option.description")
    private Double deleteBackupOlderThan;

    public boolean isUpdateSnapVaultAfterbackup() {
        return updateSnapVaultAfterbackup;
    }

    public void setUpdateSnapVaultAfterbackup(boolean updateSnapVaultAfterbackup) {
        this.updateSnapVaultAfterbackup = updateSnapVaultAfterbackup;
    }

    public boolean isUpdateSnapMirrorAfterbackup() {
        return updateSnapMirrorAfterbackup;
    }

    public void setUpdateSnapMirrorAfterbackup(
            boolean updateSnapMirrorAfterbackup) {
        this.updateSnapMirrorAfterbackup = updateSnapMirrorAfterbackup;
    }

    public int getMirrorVaultUpdateRetryCount() {
        return mirrorVaultUpdateRetryCount;
    }

    public void setMirrorVaultUpdateRetryCount(
            int mirrorVaultUpdateRetryCount) {
        this.mirrorVaultUpdateRetryCount = mirrorVaultUpdateRetryCount;
    }

    public String getSnapVaultLabel() {
        return snapVaultLabel;
    }

    public void setSnapVaultLabel(String snapVaultLabel) {
        this.snapVaultLabel = snapVaultLabel;
    }

    public Integer getDeleteBackupInExcess() {
        return deleteBackupInExcess;
    }

    public void setDeleteBackupInExcess(Integer deleteBackupInExcess) {
        this.deleteBackupInExcess = deleteBackupInExcess;
    }

    public Double getDeleteBackupOlderThan() {
        return deleteBackupOlderThan;
    }

    public void setDeleteBackupOlderThan(Double deleteBackupOlderThan) {
        this.deleteBackupOlderThan = deleteBackupOlderThan;
    }

}
