/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/NotificationParameters.java $
 *
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parameters;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.snapcenter.cli.contracts.EmailNotificationPreference;

@Parameters(resourceBundle = "snapcenter-cli")
public class NotificationParameters implements ParameterInterface {

    @Parameter(names = { "-EnableEmail" }, descriptionKey = "cli.notificationParameters.enableEmail.option.description")
    private boolean enableEmail;

    @Parameter(names = { "-EmailPreference" }, descriptionKey = "cli.notificationParameters.emailPreference.option.description")
    private EmailNotificationPreference emailNotificationPreference;

    @Parameter(names = { "-EmailFrom" }, descriptionKey = "cli.notificationParameters.emailFrom.option.description")
    private String emailFrom;

    @Parameter(names = { "-EmailTo" }, descriptionKey = "cli.notificationParameters.emailTo.option.description")
    private String emailTo;

    @Parameter(names = { "-EmailSubject" }, descriptionKey = "cli.notificationParameters.emailSubject.option.description")
    private String emailSubject;
    
    @Parameter(names = { "-EnableEmailAttachment"}, descriptionKey = "cli.notificationParameters.enableEmailAttachment.option.description")
    private boolean enableEmailAttachment;


    public boolean isEnableEmail() {
        return enableEmail;
    }

    public void setEnableEmail(boolean enableEmail) {
        this.enableEmail = enableEmail;
    }

    public EmailNotificationPreference getEmailNotificationPreference() {
        return emailNotificationPreference;
    }

    public void setEmailNotificationPreference(EmailNotificationPreference emailNotificationPreference) {
        this.emailNotificationPreference = emailNotificationPreference;
    }

    public String getEmailFrom() {
        return emailFrom;
    }

    public void setEmailFrom(String emailFrom) {
        this.emailFrom = emailFrom;
    }

    public String getEmailTo() {
        return emailTo;
    }

    public void setEmailTo(String emailTo) {
        this.emailTo = emailTo;
    }

    public String getEmailSubject() {
        return emailSubject;
    }

    public void setEmailSubject(String emailSubject) {
        this.emailSubject = emailSubject;
    }
    
    public boolean getEnableEmailAttachment() {
		return enableEmailAttachment;
	}

	public void setEnableEmailAttachment(boolean enableEmailAttachment) {
		this.enableEmailAttachment = enableEmailAttachment;
	}

}
