/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/PolicyRetentionSettingsParameters.java#1 $
 * 
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.command.parameters;

import com.netapp.smcore.loader.logger.ExtendedGenericLogger;
import com.netapp.smcore.loader.logger.LoggerFactory;
import com.netapp.snapcenter.cli.contracts.OracleBackupScope;
import com.netapp.snapcenter.cli.contracts.ScheduleType;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

/**
 * This Class defines the parameters of Retention Settings of policy.
 */
public class PolicyRetentionSettingsParameters {

    private ScheduleType scheduleType;

    private OracleBackupScope oracleBackupScope;

    private int deleteBackupInExcess;

    private int deleteBackupOlderThan;

    public static final int NUMBER_OF_SNAPSHOTS_TO_KEEP = 7;

    public static final int NUMBER_OF_DAYS_SNAPSHOTS_TO_KEEP = 14;

    private static ExtendedGenericLogger logger = LoggerFactory
            .getExtendedClassAwareLogger(PolicyRetentionSettingsParameters.class);

    public OracleBackupScope getOracleBackupScope() {
        return oracleBackupScope;
    }

    public void setOracleBackupScope(OracleBackupScope oracleBackupScope) {
        this.oracleBackupScope = oracleBackupScope;
    }

    public ScheduleType getScheduleType() {
        return scheduleType;
    }

    public void setScheduleType(ScheduleType scheduleType) {
        this.scheduleType = scheduleType;
    }

    public int getDeleteBackupInExcess() {
        return deleteBackupInExcess;
    }

    public void setDeleteBackupInExcess(int deleteBackupInExcess) {
        this.deleteBackupInExcess = deleteBackupInExcess;
    }

    public int getDeleteBackupOlderThan() {
        return deleteBackupOlderThan;
    }

    public void setDeleteBackupOlderThan(int deleteBackupOlderThan) {
        this.deleteBackupOlderThan = deleteBackupOlderThan;
    }

}
