/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/PrePostScriptParameters.java#5 $
 *
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parameters;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;

@Parameters(resourceBundle = "snapcenter-cli")
public class PrePostScriptParameters implements ParameterInterface {

    public static final int SCRIPT_DEFAULT_TIMEOUT = 60;

    @Parameter(names = { "-PreScriptPath" }, descriptionKey = "cli.prePostScriptParameters.preScriptPath.option.description")
    private String preScriptPath;

    @Parameter(names = { "-PreScriptArguments" }, descriptionKey = "cli.prePostScriptParameters.preScriptArguments.option.description")
    private String preScriptArguments;

    @Parameter(names = { "-PostScriptPath" }, descriptionKey = "cli.prePostScriptParameters.postScriptPath.option.description")
    private String postScriptPath;

    @Parameter(names = { "-PostScriptArguments" }, descriptionKey = "cli.prePostScriptParameters.postScriptArguments.option.description")
    private String postScriptArguments;

    @Parameter(names = { "-ScriptTimeout" }, descriptionKey = "cli.prePostScriptParameters.scriptTimeout.option.description")
    private int scriptTimeout = SCRIPT_DEFAULT_TIMEOUT;

    public String getPreScriptPath() {
        return preScriptPath;
    }

    public void setPreScriptPath(String preScriptCommand) {
        this.preScriptPath = preScriptCommand;
    }

    public String getPreScriptArguments() {
        return preScriptArguments;
    }

    public void setPreScriptArguments(String preScriptArguments) {
        this.preScriptArguments = preScriptArguments;
    }

    public String getPostScriptPath() {
        return postScriptPath;
    }

    public void setPostScriptPath(String postScriptCommand) {
        this.postScriptPath = postScriptCommand;
    }

    public String getPostScriptArguments() {
        return postScriptArguments;
    }

    public void setPostScriptArguments(String postScriptArguments) {
        this.postScriptArguments = postScriptArguments;
    }

    public int getScriptTimeout() {
        return scriptTimeout;
    }

    public void setScriptTimeout(int scriptTimeout) {
        this.scriptTimeout = scriptTimeout;
    }

}