/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/ResourceGroupScheduleParameters.java#1 $
 * 
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parameters;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.builder.ToStringBuilder;

import com.netapp.snapcenter.cli.contracts.DaysOfTheWeek;
import com.netapp.snapcenter.cli.contracts.MonthsOfTheYear;
import com.netapp.snapcenter.cli.contracts.ScheduleType;

public class ResourceGroupScheduleParameters {

    private ScheduleType scheduleType = ScheduleType.NONE;

    private String policyName;

    private Date startTime;

    private Date endTime;

    private int repeatTaskEveryHour = 1;

    private int repeatTaskEveryMins;

    private int occursEveryMinute;

    private int occursEveryMonth;

    private short daysInterval = 1;

    private List<String> daysOfTheWeekAsStringList = new ArrayList<>();

    private List<String> monthsOfTheYearAsStringList = new ArrayList<>();

    private List<Integer> daysOfTheMonth = new ArrayList<>();

    private List<DaysOfTheWeek> daysOfTheWeek = new ArrayList<DaysOfTheWeek>();

    private List<MonthsOfTheYear> monthsOfTheYear = new ArrayList<MonthsOfTheYear>();

    public String getPolicyName() {
        return policyName;
    }

    public void setPolicyName(String policyName) {
        this.policyName = policyName;
    }

    public ScheduleType getScheduleType() {
        return scheduleType;
    }

    public void setScheduleType(ScheduleType scheduleType) {
        this.scheduleType = scheduleType;
    }

    public Date getStartTime() {
        return startTime;
    }

    public void setStartTime(Date startTime) {
        this.startTime = startTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public void setRepeatTaskEveryHour(int repeatTaskEveryHour) {
        this.repeatTaskEveryHour = repeatTaskEveryHour;
    }

    public int getRepeatTaskEveryHour() {
        return repeatTaskEveryHour;
    }

    public void setRepeatTaskEveryMins(int repeatTaskEveryMins) {
        this.repeatTaskEveryMins = repeatTaskEveryMins;
    }

    public int getRepeatTaskEveryMins() {
        return repeatTaskEveryMins;
    }

    public int getOccursEveryMinute() {
        return occursEveryMinute;
    }

    public void setOccursEveryMinute(int occursEveryMinute) {
        this.occursEveryMinute = occursEveryMinute;
    }

    public int getOccursEveryMonth() {
        return occursEveryMonth;
    }

    public void setOccursEveryMonth(int occursEveryMonth) {
        this.occursEveryMonth = occursEveryMonth;
    }

    public short getDaysInterval() {
        return daysInterval;
    }

    public void setDaysInterval(short daysInterval) {
        this.daysInterval = daysInterval;
    }

    public List<DaysOfTheWeek> getDaysOfTheWeek() {
        return daysOfTheWeek;
    }

    public void setDaysOfTheWeek(List<DaysOfTheWeek> daysOfTheWeek) {
        this.daysOfTheWeek = daysOfTheWeek;
    }

    public List<MonthsOfTheYear> getMonthsOfTheYear() {
        return monthsOfTheYear;
    }

    public void setMonthsOfTheYear(List<MonthsOfTheYear> monthsOfTheYear) {
        this.monthsOfTheYear = monthsOfTheYear;
    }

    public List<Integer> getDaysOfTheMonth() {
        return daysOfTheMonth;
    }

    public void setDaysOfTheMonth(List<Integer> daysOfTheMonth) {
        this.daysOfTheMonth = daysOfTheMonth;
    }

    public List<String> getDaysOfTheWeekAsStringList() {
        return daysOfTheWeekAsStringList;
    }

    public void setDaysOfTheWeekAsStringList(List<String> daysOfTheWeekAsStringList) {
        this.daysOfTheWeekAsStringList = daysOfTheWeekAsStringList;
    }

    public List<String> getMonthsOfTheYearAsStringList() {
        return monthsOfTheYearAsStringList;
    }

    public void setMonthsOfTheYearAsStringList(List<String> monthsOfTheYearAsStringList) {
        this.monthsOfTheYearAsStringList = monthsOfTheYearAsStringList;
    }
    
    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this);
    }

}
