/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/SMOBackupDataSetParameters.java#5 $
 *
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parameters;

import java.util.ArrayList;
import java.util.List;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.snapcenter.cli.command.parser.CommaParameterSplitter;

@Parameters(resourceBundle = "snapcenter-cli")
public class SMOBackupDataSetParameters implements ParameterInterface {

    public static final String BACKUP_ARCHIVELOG_BEFORE_MISSINGFILES = "BackupArchiveLogs";
    public static final String ARCHIVED_LOGS_EXCLUDE_FILESLIKE = "ExcludeArchiveLogPathList";

    @Parameter(names = { "-BackupArchiveLogsAfterRecentMissingOne" }, descriptionKey = "cli.smoBackupDataSetParameters.backupArchiveLogsAfterRecentMissingOne.option.description")
    private boolean backupArchiveLogsAfterRecentMissingOne;

    @Parameter(names = { "-ExcludeArchiveLogDestinationsFromBackup" }, descriptionKey = "cli.smoBackupDataSetParameters.excludeArchiveLogDestinationsFromBackup.option.description", splitter = CommaParameterSplitter.class)
    private List<String> excludeArchiveLogDestinationsFromBackup = new ArrayList<>();

    public boolean isBackupArchiveLogsAfterRecentMissingOne() {
        return backupArchiveLogsAfterRecentMissingOne;
    }

    public void setBackupArchiveLogsAfterRecentMissingOne(
            boolean backupArchiveLogsAfterRecentMissingOne) {
        this.backupArchiveLogsAfterRecentMissingOne = backupArchiveLogsAfterRecentMissingOne;
    }

    public List<String> getExcludeArchiveLogDestinationsFromBackup() {
        return excludeArchiveLogDestinationsFromBackup;
    }

    public void setExcludeArchiveLogDestinationsFromBackup(
            List<String> excludeArchiveLogDestinationsFromBackup) {
        this.excludeArchiveLogDestinationsFromBackup = excludeArchiveLogDestinationsFromBackup;
    }
}