/*
 * $Id: //depot/prod/spl/main_next/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parser/AuthModeCoverter.java#1 $
 * 
 * Copyright (c) 2018 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.command.parser;

import com.beust.jcommander.IStringConverter;
import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.contracts.AuthMode;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.utils.CLIUtils;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

public class AuthModeCoverter implements IStringConverter<AuthMode> {

	@Override
	public AuthMode convert(String value) {
		if (value.equalsIgnoreCase(AuthMode.ORACLEASM.value())
				|| value.equalsIgnoreCase(AuthMode.ORACLEDATABASE.value())
				|| value.equalsIgnoreCase(AuthMode.ORACLERMANCATALOG.value())) {
			return AuthMode.fromValue(value);
		}
		try {
			return CLIUtils.getEnumFromValue(AuthMode.class, value);
		} catch (CLIException e) {
			throw new IllegalArgumentException(
					MessageBundle
							.localizeMessage(
									CLIMsgKey.CLI_ENUM_CONVERSION_INVALID_VALUE,
									value,
									"-AuthMode",
									"[WINDOWS, LINUX, ORACLEDATABASE, ORACLEASM, ORACLERMANCATALOG]"));

		}
	}

}
