/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parser/CustomHHMMStringToHoursAndMinutesConverter.java#1 $
 *
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */



package com.netapp.snapcenter.cli.command.parser;

import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;
import org.apache.commons.lang3.time.DateUtils;

import java.text.ParseException;
import java.util.Date;


public class CustomHHMMStringToHoursAndMinutesConverter {

    public static final String hhmmPatternForParsing = "HH:mm";

    private CustomHHMMStringToHoursAndMinutesConverter(){

    }

    public static Date convertToHHMMformat(String value) throws CLIException {
        Date date = new Date();
        try {

            date = DateUtils.parseDateStrictly(value,hhmmPatternForParsing);
        } catch (ParseException e) {
            throw new CLIException(MessageBundle.localizeMessage(CLIMsgKey.CLI_SCHEDULE_REPEATEVERYHOUR_FORMAT_ERROR));
        }

        return date;
    }

}
