/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/contracts/RetentionSettingsArguments.java#1 $
 * 
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.contracts;

import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

public enum RetentionSettingsArguments {
    SCHEDULETYPE("scheduletype"), BACKUPSCOPE("backupscope"), RETENTIONCOUNT(
            "retentioncount"), RETENTIONDAYS("retentiondays");

    private final String value;

    RetentionSettingsArguments(String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    public static RetentionSettingsArguments fromValue(String string) {
        for (RetentionSettingsArguments c : RetentionSettingsArguments.values()) {
            if (c.value.equalsIgnoreCase(string)) {
                return c;
            }
        }
        throw new IllegalArgumentException(MessageBundle.localizeMessage(
                CLIMsgKey.CLI_SMPOLICY_INVALID_RETENTION_SETTINGS_ARGUMENTS,
                string));

    }

}
