/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/formatter/FormatterFactory.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.formatter;

public class FormatterFactory {

    private FormatterFactory() {

    }

    public static Formatter getFormatter(FormatterType formatterType) {

        Formatter formatter = null;
        switch (formatterType) {
            case TEXT:
                formatter = new TextFormatter();
                break;

            case XML:
                formatter = new XMLFormatter();
                break;

            case JSON:
                formatter = new JSONFormatter();
                break;
                
            case TEXT_TABLE:
                formatter = new TextTableFormatter();
                break;
                
            default:
                formatter = new TextTableFormatter();
                break;
        }
        return formatter;
    }
}
