/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/utils/TokenStoreUtil.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.utils;

import java.io.IOException;

import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.spl.common.security.SecurityTokenStore;
import com.netapp.spl.common.security.SecurityTokenStoreInterface;

public class TokenStoreUtil {

    private TokenStoreUtil() {

    }

    public static String readToken() throws CLIException {
        String token = null;
        try {
            SecurityTokenStoreInterface securityTokenStore = SecurityTokenStore
                    .getInstance();
            token = securityTokenStore.readToken();
        } catch (IOException e) {
            /**
             * TODO: This should be an unexpected error and we need to decide on
             * what to print and what to put into debug log.
             */
            throw new CLIException(e.getLocalizedMessage());
        }
        return token;
    }

    public static void writeToken(String token) throws CLIException {
        try {
            SecurityTokenStoreInterface securityTokenStore = SecurityTokenStore
                    .getInstance();
            securityTokenStore.writeToken(token);
        } catch (IOException e) {
            /**
             * TODO: This should be an unexpected error and we need to decide on
             * what to print and what to put into debug log.
             */
            throw new CLIException(e.getLocalizedMessage());
        }
    }

}